%define version 5.4.46
%define mversion 5.0.9
%define gcc-ver 2.7.2.3

Name: libc5
Summary: standard shared libraries for programs
Version: %{version}
Release: 2
ExclusiveArch: i386 i586 
ExclusiveOS: Linux
Copyright: distributable
Group: Libraries
Packager: Red Hat Contrib|Net <rhcn-bugs@redhat.com>
Distribution: Red Hat Contrib|Net
Vendor: The Seawood Project
Source: sunsite.unc.edu:/pub/Linux/GCC/libc-%{version}.tar.gz
Patch0: libc5-5.4.46-config.patch
Patch1: libc5-5.4.46-locale.patch
Patch2: libc5-5.4.38-wchar.patch
Patch3: libc5-5.4.44-makeconfig.patch
BuildRoot: /var/tmp/build-%{name}
Provides: libc5

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers binutils %{name} = %{version}

%package static
Summary: Libraries for static linking
Group: Development/Libraries/Libc
Requires: binutils %{name} = %{version}

%package profile
Summary: libc with profiling support
Group: Development/Libraries/Libc
Requires: binutils %{name} = %{version}

%package debug
Summary: libc with debugging information
Group: Development/Libraries/Libc
Requires: binutils %{name} = %{version}

%changelog
* Fri Nov 06 1998 Christopher Seawood <cls@seawood.org>
- Added RHCN field
- Added libc5 to requires field of subpackages

* Thu Jul 30 1998 Christopher Seawood <cls@seawood.org>
- Upgraded to ver 5.4.46

* Mon Apr 13 1998 Christopher Seawood <cls@seawood.org>
- Upgraded to ver 5.4.44

* Mon Jan 12 1998 Christopher Seawood <cls@seawood.org>
- Added i586 to exclusive arch
- Automatically added /usr/i486-linuxlibc5/lib to /etc/ld.so.conf
- Added option to specify gcc-version

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to 
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a 
Linux system will not function.

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%description static
While most programs are distributed dynamically linked, and therefore need
access to the standard shared libraries, some developers prefer to
ship programs statically linked, which includes all of the standard library
code in the executable. While this results in significantly larger 
programs and increases their memory usage, it does increase the portability
of programs between Linux systems.

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them. 

#%package locale
#Summary: Tools for manipulation locale definition files for other languages
#Group: Utilities/Text
#%description locale
#This package includes the tools necessary to generate and manipulate the
#locale definition files that libc uses to provide multi-lingual support.

%prep
%setup -c -q

%patch0 -p1 -b .cfg
%patch1 -p0 -b .locale
%patch2 -p1 -b .wc

cd include
# Assumes that the kernel sources are in their standard places...
ln -s /usr/src/linux/include/linux .
ln -s /usr/src/linux/include/asm .

cd ../libc
mv config.in config.in.tmpl
sed "s&REPLACEMEWITHTARGET&$RPM_BUILD_ROOT/&" < config.in.tmpl > config.in
mv config.in config.in.tmpl
sed "s&REPLACEMEWITHGCCVERSION&%{gcc-ver}&" < config.in.tmpl > config.in
rm -f config.in.tmpl

cd ..
%patch3 -p1 -b .mkcfg

%build

cd libc

./configure <<EOF

EOF
make
#make -C locale locale localedef

%install

if [ "X$RPM_BUILD_ROOT" != "X" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/usr/i486-linuxlibc5/{bin,lib,include}

rm -f include/*.inc include/*.mkcfg include/*.wc
tar cvSpf - include | (cd $RPM_BUILD_ROOT/usr/i486-linuxlibc5; tar xSpf -)

# this comes from the linuxthreads package
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/pthread.h

#install -m755 -s libc/locale/locale $RPM_BUILD_ROOT/usr/i486-linuxlibc5/bin/locale
#install -m755 -s libc/locale/localedef $RPM_BUILD_ROOT/usr/i486-linuxlibc5/bin/localedef

cd libc
make RPM_BUILD_ROOT="$RPM_BUILD_ROOT" install

rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/linux $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/asm
ln -sf ../../src/linux/include/linux $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/linux
ln -sf ../../src/linux/include/asm $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/asm

install -m644 nys/nsw/etc/nsswitch.conf $RPM_BUILD_ROOT/etc

cd $RPM_BUILD_ROOT/usr/i486-linuxlibc5/lib
rm -f libc.so libm.so
ln -s libc.so.%{version} libc.so
ln -s libm.so.%{mversion} libm.so
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/ansidecl.h
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/obstack.h

%clean
if [ "X$RPM_BUILD_ROOT" != "X" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%post
grep "^/usr/i486-linuxlibc5/lib$" /etc/ld.so.conf >/dev/null 2>&1
[ $? -ne 0 ] && echo "/usr/i486-linuxlibc5/lib" >> /etc/ld.so.conf
/sbin/ldconfig

%postun
if [ "$1" = "0" ]; then
        grep -v "/usr/i486-linuxlibc5/lib" /etc/ld.so.conf > /etc/ld.so.conf.new
        mv -f /etc/ld.so.conf.new /etc/ld.so.conf
fi
/sbin/ldconfig

%files
%doc libc/README.nys libc/nys/README libc/nys/nis/etc/nis.conf libc/nys/yp/etc/yp.conf
%config /etc/nsswitch.conf
/usr/i486-linuxlibc5/lib/libm.so.%{mversion}
/usr/i486-linuxlibc5/lib/libc.so.%{version}

%files devel
/usr/i486-linuxlibc5/include
/usr/i486-linuxlibc5/lib/*.o
/usr/i486-linuxlibc5/lib/lib*.so
/usr/i486-linuxlibc5/lib/libbsd.a

%files static
/usr/i486-linuxlibc5/lib/libc.a
/usr/i486-linuxlibc5/lib/libm.a

%files profile
/usr/i486-linuxlibc5/lib/libc_p.a
/usr/i486-linuxlibc5/lib/libgmon.a
/usr/i486-linuxlibc5/lib/libmcheck.a

%files debug
/usr/i486-linuxlibc5/lib/libg.a

#%files locale
#/usr/i486-linuxlibc5/bin/locale
#/usr/i486-linuxlibc5/bin/localedef
